var _ = require('underscore');

var Base = require('./base.js');

function Handlebars() {
	Base.call(this);
}

Handlebars.prototype = Object.create(Base.prototype);
Handlebars.prototype.constructor = Base;

Handlebars.prototype.init = function(conf) {
	this.conf = conf;
};

Handlebars.prototype.add = function(key, dest, sources, options) {

	var self = this;
	options = options || {};

	var files = {};
	files[dest] = sources;

	var hbsoptions = {};

	if (options.partialsPathRegex) {

		// make them all partials
		hbsoptions.partialRegex = /\.hbs$/;

		hbsoptions.partialsPathRegex = options.partialsPathRegex;

		if(options.components){

			hbsoptions.processPartialName = function(filePath) {

				var relativePath = filePath.replace(self.conf.sources.components + '/', '');

				var componentName = relativePath.split('/').pop().replace('.hbs', '');
				var namespace = relativePath.split('/').shift();
				var componentString;

				if (self.conf.sources.componentsOptions && self.conf.sources.componentsOptions[namespace] && self.conf.sources.componentsOptions[namespace].atomic) {
					componentString = [
						namespace,
						relativePath.split('/')[1],
						componentName
					].join('/');
				}

				else {
					componentString = namespace + '/' + componentName;
				}

				return componentString;

			};

		}else if(options.themes){
			hbsoptions.processPartialName = function(filePath) {
				var relativePath = filePath.replace(self.conf.sources.themes + '/', '');
				var partialName = filePath.split('/').pop().replace('.hbs', '');
				var themeName = relativePath.split('/').shift();
				return themeName + '/' + partialName;
			};

			hbsoptions.processName = function(filePath){
				var relativePath = filePath.replace(self.conf.sources.themes + '/', '');
				return relativePath.replace('.hbs', '');
			};
		}


	}

	this.config[key] = {
		files: files,
		options: hbsoptions
	};

};

module.exports = Handlebars;

