var fs = require('fs'),
	path = require('path');

module.exports = {

	init: function(conf) {
		this.conf = conf;
	},

	createTasks: function(gruntHelper, taskName){
		var themes = this.getThemesFromFiles(this.conf.sources.themes),
			files,themeName;
		for (var i = 0; i < themes.length; i++) {
			themeName = themes[i].name;
			files = [
				path.join(this.conf.sources.components, 'variables.css'),
				path.join(this.conf.sources.themes, themeName, 'css', 'variables.css'),
				path.join(this.conf.output.css.base, 'theme-base.css'),
				path.join(this.conf.sources.themes, themeName, 'css', 'skin.css')
			];
			gruntHelper.concat.add(taskName, path.join(this.conf.output.css.themes, themeName + '.css'), files);
		}
	},

	getThemesFromFiles: function(themesPath){
		var dirs = fs.readdirSync(themesPath),
			themes = [],
			theme,themeConfig;
		for (var i = 0; i < dirs.length; i++) {
			themeConfig = this.getThemeConfig(dirs[i]);
			theme = {
				name: dirs[i],
				dependencies: themeConfig.dependencies
			};
			themes.push(theme);
		}
		return themes;
	},

	getThemeConfig: function(themeName){
		var config = {};
		try{
			config = JSON.parse(fs.readFileSync(path.join(this.conf.sources.themes, themeName, 'config.json')));
		}catch(err){
			config = {};
		}
		return config;
	}
};