/* global $,_ */
/*jshint browser:true*/
$(function(){

	window.SIFE = {};

	var hrefParts = window.location.href.split('?');
	if(!hrefParts[1]){
		var select = '<select onchange="window.location.href=\''+hrefParts['0']+'?\'+this.value"><option>Choose what to render...</option>';
		for(var tplKey in window.JST){
			select+='<option>'+tplKey+'</option>';
		}
		select+='</select>';
		document.body.innerHTML = select;
	}else{
		if(hrefParts[1].split('#').length===2){
			hrefParts[1] = hrefParts[1].split('#')[0];
		}
		var themeName = hrefParts[1].split('/')[0];
		window.SIFE.themePath = hrefParts[1];

		// first, load the data
		var jsonUrl = 'themes/'+themeName+'/data/standard.json';
		var optionsUrl = 'themes/'+themeName+'/config.json';
		// and css
		var cssPromise = $.Deferred();
		var cssLoaded = 0;
		var cssHasLoaded = function(){
			cssLoaded++;
			console.log('cssLoaded', cssLoaded);
			if(cssLoaded===1){
				cssPromise.resolve();
			}
		};
		var cssUrl = '__output__/css/themes/'+themeName+'.css';
		var css = document.createElement('link');
		css.rel = 'stylesheet';
		css.onload = cssHasLoaded;
		css.type= 'text/css';
		css.href= cssUrl;
		document.getElementsByTagName("head")[0].appendChild(css);


		$.when(
			$.getJSON(jsonUrl),
			$.getJSON(optionsUrl),
			cssPromise
		).then(function(dataResp, optionsResp){

			window.SIFE.data = dataResp[0];
			window.SIFE.options = optionsResp[0];

			// then render
			renderTemplate();

			$('#SIFE-optionDrawer').html(
				'<button class="pure-button pure-button-primary SIFE-js-preview">Preview</button>'
			+	'<button class="pure-button SIFE-js-close-drawer">Close</button>'
			+	'<div class="SIFE-option-header">CONFIG</div>'
			+	'<div class="u-l-box SIFE-js-options-config">'+renderOptionsDrawer(window.SIFE.options.vars)+'</div>'
			+	'<div class="SIFE-option-header">STYLE</div>'
			+	'<div class="u-l-box SIFE-js-options-style">'+renderOptionsDrawer(window.SIFE.options.style)+'</div>'
			);

		}).fail(function(){
			console.error('Failed to load JSON');
		});

		$(document.body).delegate('#SIFE-openDrawer,.SIFE-js-close-drawer','click', function(){
			$('#SIFE-optionDrawer').toggleClass('SIFE-optionDrawer--opened');
		});

		$(document.body).delegate('.SIFE-js-preview', 'click', function(){
			// gather data
			$('.SIFE-js-options-config').find('input').each(function(){
				var key = this.name,val;
				// modify SIFE.data
				switch(this.type){
					case 'checkbox':
						val = this.checked;
						break;
					default:
						val = $(this).val();
				}

				window.SIFE.data[key] = val;

			});

			// re-render
			renderTemplate();

			// gather styles
			// @TODO check of they actually changed
			var stylesVars = {};
			$('.SIFE-js-options-style').find('input').each(function(){
				var key = this.name,val;

				switch(this.type){
					default:
						val = $(this).val();
				}

				if($(this).attr('data-option-value-type')==='integer'){
					val+='px';
				}

				stylesVars[key] = val;
			});

			// insert dynamic css
			var css = document.createElement('link');
			css.rel = 'stylesheet';
			css.type= 'text/css';
			css.href= 'dynamic-css-vars/'+themeName+'/?'+encodeURIComponent(JSON.stringify(stylesVars));
			document.getElementsByTagName("head")[0].appendChild(css);

		});


		$(window).on('hashchange', function(){
			var id = window.location.hash.substr(4);
			window.SIFE.data._currentPageId = parseInt(id, 10);
			renderTemplate();
		});


		var renderTemplate = function(){
			if(!window.SIFE.data._currentPageId){
				window.SIFE.data._currentPageId = 1;
			}

			var currentPage = _.findWhere(window.SIFE.data._pages, {uid:window.SIFE.data._currentPageId});

			console.log(currentPage);
			var data = window.SIFE.data;
			if(currentPage._variables){
				data = _.extend({}, data, currentPage._variables);
			}
			console.log(data);

			$('#SIFE-js-render-template-target').html(window.JST[window.SIFE.themePath](data));
		};

		var renderOptionsDrawer = function(options){
			var html = '';
			_.each(options, function(config, key){
				html+= '<div class="SIFE-theme-option">';
				html+=	'<div class="SIFE-theme-option__key">'+key+'</div>';
				html+=	'<div class="SIFE-theme-option__description">'+config.description+'</div>';
				html+=	'<div class="SIFE-theme-option__field">'+renderOptionField(config.value, key)+'</div>';
				html+= '</div>';
			});
			return html;
		};

		var renderOptionField = function(value, key){
			if(!value) return 'Error: Missing value';
			var html = '';
			switch(value.type){
				case 'integer':
					html='<span id="SIFE-option-value-label-'+key+'" class="SIFE-option-value-label">'+value.default+'</span>';
					html+= '<input type="range" name="'+key+'" value="'+value.default+'" min="'+value.min+'" max="'+value.max+'" data-option-value-type="'+value.type+'" oninput="$(\'#SIFE-option-value-label-'+key+'\').text(this.value)">';
					break;

				case 'boolean':
					html= '<label class="pure-checkbox">';
					html+='<input type="checkbox" name="'+key+'" '+(value.default ? 'checked' : '')+'> Enable';
					html+='</label>';
					break;

				case 'color':
					html='<input type="color" name="'+key+'" value="'+value.default+'">';
					break;

				case 'string':
					html='<input type="text" name="'+key+'" value="'+value.default+'">';
					break;
			}
			return html;
		};

	}
});