describe 'concat', ->
	Given -> @subject = @subject.concat
	Then -> typeof @subject == 'object'
	Then -> typeof @subject.add == 'function'

	beforeEach -> @subject.reset()

	describe 'add 1', ->
		When -> @subject.add('foo', 'out.file', ['source.file'])
		Then -> expect(@subject.config).toEqual({foo:{files:[{'out.file':['source.file']}]}})

	describe 'add 2 keys', ->
		When ->
			@subject.add('foo', 'outfoo.file', ['source.file'])
			@subject.add('bar', 'bar.file', ['source.file'])
		Then -> expect(@subject.config).toEqual({
			foo:{files:[{'outfoo.file':['source.file']}]},
			bar:{files:[{'bar.file':['source.file']}]}
		})

	describe 'add to existing key', ->
		When ->
			@subject.add('foo', 'outfoo.file', ['source.file'])
			@subject.add('foo', 'outfoo2.file', ['whatever'])

		Then -> expect(@subject.config).toEqual({
			foo:{files:[
				{'outfoo.file':['source.file']},
				{'outfoo2.file':['whatever']}
			]},
		})